SketchUp C API

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Class Hierarchy
This inheritance list is sorted roughly, but not completely, alphabetically:
[detail level 1 2 3 4]

SketchUpModelExporterInterface | A valid SketchUp "exporter" plugin must support the following interface. See the SDK samples for an example
SketchUpModelImporterInterface | A valid SketchUp "importer" plugin must support the following interface. See the SDK samples for an example
SketchUpPluginProgressCallback | Interface to provide import/export progress feedback and cancellation
SUAxisAlignedRect2D | Represents a 2D rectangle that is aligned with the X and Y axis of the coordinate system. The coordinates of the points of the rectangle are in inches
SUBeginFrameInfo | Information about the frame camera and viewport that is passed to SUOverlayCreateInfo::begin_frame
SUBoundingBox3D | Represents a 3D axis-aligned bounding box represented by the extreme diagonal corner points with minimum and maximum x,y,z coordinates. The coordinates of the points are in inches
SUCameraRef | References the camera object of a SketchUp model
SUClassificationAttributeRef | References attribute data about a classified component
SUClassificationInfoRef | References an object with classification information. Each SUClassificationInfoRef contains the names of the schemas and the schema types, and the types attributes. See SUClassificationAttributeRef for details on the type attributes
SUClassificationsRef | Used to manage a Classifications object
SUColor | Stores a RGBA color with 8 bit channels
SUColorOrder | A simple struct with four indices indicating the ordering of color data within 32-bit bitmap images. 32-bit bitmap images have 4 channels per pixel: red, green, blue, and alpha where the alpha channel indicates the transparency of the pixel. SketchUpAPI expects the channels to be in different orders on Windows vs. Mac OS. Bitmap data is exposed in BGRA and RGBA byte orders on Windows and Mac OS, respectively. The color order indices facilitate platform independent code when it is necessary to manipulate image pixel data. The struct's data also applies to 24-bit bitmap images except that such images don't have an alpha channel so the SUColorOrder::alpha_index varaible can be ignored
SUComponentBehavior | Describes how the component behaves in a SketchUp model, e.g. how it glues to surfaces
SUDimensionStyleRef | A dimension style reference
SUDrawFrameMemoryBuffer | Memory buffer (for color and depth) info used in SUOverlayDrawFrameInfo
SUDynamicComponentAttributeRef | References attribute data about a dynamic component
SUDynamicComponentInfoRef | References an object with information about a dynamic component
SUEntitiesParent | Reference to the parent of an SUEntitiesRef object
SUEntitiesRef | References a container object for all entities in a model, component definition or a group
SUEntityListIteratorRef | References an entity list iterator object
SUEntityListRef | References an entity list
SUEntityRef | References an entity, which is an abstract base type for most API types
SUAttributeDictionaryRef | A dictionary type with SUStringRef objects as keys and SUTypedValueRef objects as values
SUAxesRef | An axes entity reference
SUComponentDefinitionRef | References a component definition
SUCurveRef | References a curve
SUArcCurveRef | References an arccurve
SUDrawingElementRef | References a drawing element, which is an abstract base type for some API types
SUComponentInstanceRef | References a component instance, i.e. an instance of a component definition
SUGroupRef | References a group object
SUDimensionRef | A dimension entity reference
SUDimensionLinearRef | A linear dimension entity reference
SUDimensionRadialRef | A radial dimension entity reference
SUEdgeRef | References an edge
SUFaceRef | References a face
SUGuideLineRef | A guide line that has a start and end position
SUGuidePointRef | A guide point that has a position
SUImageRef | References an image object
SUSectionPlaneRef | A sectionPlane entity reference
SUSnapRef | References a snap
SUTextRef | A text entity reference
SUEdgeUseRef | SUEdgeUseRef objects are used to retrieve the topology of the edges of a polygon. The geometry of the polygon being represented by SULoopRef that is already associated with a face object. The typical use of EdgeUse object is to retrieve them from a face object's loop, and then read the topology values from them
SUFontRef | A font entity reference
SULayerRef | References a Tag object
SULineStyleRef | References a line style
SULoopRef | References a loop object, which can be either the outer loop or an inner loop (hole) of a face
SUMaterialRef | References a material object
SUPolyline3dRef | A polyline3d object. These are curve-like entities that do not generate inference snaps or affect geometry in any way
SUSceneRef | Used to get and set a scene's camera views, using the SUCameraRef object
SUStyleRef | A style entity reference
SUTextureRef | Used to manage image data that can be associated with any SUEntityRef
SUVertexRef | A vertex type that has a position and is associated with other geometry like edges, faces, and loops
SUEnvironmentRef | References an environment, which enables sky boxes and image-based lighting
SUEnvironmentsRef | References a container object for all environments in a model
SUExtensionLicense | Stores extension license information
SUFontInfo | Information about the font that is to be created by SUModelAddFont
SUGeometryInputRef | References a geometry input object. It is used as an input to SUEntitiesFill()
SUImageRepRef | References an image representation object
SUInstancePathRef | An instance path type that provides a wrapping of a data structure of component instances
SULayerFolderRef | References a Tag Folder object
SULengthFormatterRef | References a length formatter object. Length formatters are used to generate formatted strings (optionally with units) from length, area, and volume values. Additionally length formatters can be used to translate a formatted length/area/volume string into a value. Accessors and setters are exposed for some of the key formatting properties, facilitating customization of the formater. In cases when users want the formatter to reflect the properties of a model, SUModelGetLengthFormatter should be used to more efficiently extract/copy the relevant properties from the model to the formatter
SULineStylesRef | Provides access to the different line style objects in the model
SULocationRef | References a type that contains location information of a model (e.g. latitude, longitude)
SULoopInputRef |
SUMaterialInput | SUMaterialInput contains information that is needed to apply a material to a face
SUMaterialPositionInput | SUMaterialInput contains information that is needed to apply a material to a face
SUMeshHelperRef | A helper class that will tessellate a SUFaceRef object into triangles, and then provide the vertices, normals, and STQ coordinates of those triangles
SUModelRef | A SketchUp model
SUModelStatistics | Contains an array of entity counts that can be indexed per entity type
SUOpeningRef | References an opening object, which is a hole in a face created by an attached component instance or group
SUOptionsManagerRef | Provides access to the different options provider objects in the model. Available options providers are: PageOptions, SlideshowOptions, UnitsOptions and PrintOptions
SUOptionsProviderRef | Provides ability to get and set options on an options provider object. Available options providers are: PageOptions, SlideshowOptions, UnitsOptions and PrintOptions
SUOverlayCreateInfo | Arguments for creating an overlay object
SUOverlayDrawFrameInfo | Data that SketchUp will use the to blend the given color/depth buffer onto SketchUp rendering
SUOverlayRef | Manages a Overlay object, which is used to blend external images on top of SketchUp rendering
SUPlane3D | Represents a 3D plane by the parameters a, b, c, d. For any point on the plane, ax + by + cz + d = 0. The coeficients are normalized so that a*a + b*b + c*c = 1
SUPoint2D | Represents a point in 2-dimensional space. The coordinates are represented in inches
SUPoint3D | Represents a point in 3-dimensional space. The coordinates are represented in inches
SURay3D | Represents a 3D ray defined by a point and normal vector. The coordinates of the point are represented in inches
SURenderingOptionsRef | Used to get and set values in a rendering options object
SUSchemaRef | Used to manage a Schema object
SUSchemaTypeRef | Used to manage a SchemaType object
SUSelectionRef | References a the model selection. This is only available from within the SketchUp application
SUShadowInfoRef | Used to get and set values in a shadow info object
SUStringRef | Stores a Unicode string for use as output string parameters in the API
SUStylesRef | A styles entity reference
SUTextureWriterRef | Used to write out textures of various SketchUp model elements to local disk. For face objects texture writer modifies non-affine textures on write so that the resulting texture image can be mapped with 2-dimensional texture coordinates. The modified UV coordinates are retrieved from a mesh object created with SUMeshHelperCreateWithTextureWriter()
SUTransformation | Represents a 3D (4x4) geometric transformation matrix
SUTransformation2D | Represents a 2D (2x3) affine transformation matrix. The matrix is stored in column-major format:
SUTypedValueRef | Variant object used to represent the value of a key-value attribute pair
SUUVHelperRef | Used to compute UV texture coordinates for a particular face
SUUVQ | Stores UV texture coordinates
SUVector2D | Represents a vector in 2-dimensional space. The magnitudes are represented in inches
SUVector3D | Represents a vector in 3-dimensional space. The magnitudes are represented in inches